//gcc -lnsl -lresolv countdown.c -o countdown && ./countdown 127.0.0.1 1024

#include "TCP_Client.c"
#include <time.h>
#include <sys/time.h>

static unsigned long getdiff(struct timeval *first, struct timeval *second);

int main(int argc, char *argv[])
{	
	if(argc!=4)
	{
		printf("Usage: ./countdown <Servername> <Port> <min:sek>oder<sek>\n");
		exit(1);
	}
	
	printf("Server: %s\n",argv[1]);
	printf("Port: %i\n",atoi(argv[2]));
	
	init((argv[1]), atoi(argv[2]));
	
	//momentane Zeit holen
	struct timeval starttime, nowtime;
	gettimeofday(&starttime,(struct timezone *)0);
	
	//Countdownzeit draufaddieren
	unsigned long counttime;
	if(NULL == strchr (argv[3], ':')){
		//kein : -> nur Sekunden
		counttime = strtoul (argv[3], NULL, 10);
	}else{
		//Minuten und Sekunden
		char *pEnd;
		counttime = strtoul(argv[3], &pEnd, 10);
		counttime *= 60;
		counttime += strtoul (argv[3], NULL, 10);
	}
	starttime.tv_sec += counttime;
	
	unsigned millis;
	unsigned secs;
	unsigned minutes;
	
	char zeile1[7];
	char zeile2[7];
	
	while(1){
	
		//Zeit holen und Differenz bilden
		gettimeofday(&nowtime,(struct timezone *)0);
		counttime = getdiff(&nowtime, &starttime);
		
		counttime /= 1000;
		millis = counttime%1000;
		counttime /= 1000;
		secs = counttime%60;
		counttime /= 60;
		minutes = counttime;
		
		//printf("countdown: %lu -> %u:%u:%u\n", counttime, minutes, secs, millis);
		//printf("now: %u, start: %u\n", nowtime.tv_sec, starttime.tv_sec);
		
		//Anzeigen
		resetScreen();
		snprintf(zeile1, sizeof(zeile1), "%03u:%02u", minutes, secs);
		snprintf(zeile2, sizeof(zeile2), "%03u", millis);
		scprintf(zeile1, 1, 0, 255);
		scprintf(zeile2, 6, 6, 255);
		display();
		
		usleep(5000);
		
		//zuende?
		if((0 == millis) && (0 == secs) && (0 == minutes)){
			break;
		}
	
	}
	
	while(1){
		//FUMP!
		resetScreen();
		scprintf("FUMP!", 3, 3, 255);
		display();
		usleep(500000);	
		resetScreen();
		scprintf("FUMP!", 3, 3, 2<<5);
		display();
		usleep(500000);
	}
	
	return 0;
}

static unsigned long getdiff(struct timeval *first, struct timeval *second){

	unsigned long erg;
	
	if (first->tv_sec > second->tv_sec){
		//first ist größer als second -> Countdown beendet
		return 0;
	}
	
	if (first->tv_sec == second->tv_sec){
		if(first->tv_usec >= second->tv_usec){
			//first ist größer als second -> Countdown beendet
			return 0;
		}
	}

	if (first->tv_sec < second->tv_sec){
		//sekunden sind bereits fortgeschritten -> usecs über Sekundenabschnitt berechnen
		erg  = (second->tv_sec - first->tv_sec)*(unsigned long)1000000;
		erg += ((unsigned long)1000000 - first->tv_usec);
		erg += second->tv_usec;
	}else{
		erg = second->tv_usec - first->tv_usec;
	}
	
	return erg;	

}
