//gcc -lnsl -lresolv -lcurses pong.c -o pong && ./pong 127.0.0.1 1024

#include "TCP_Client.c"
#include <time.h>
#include "curses.h"
#include <error.h>
#define padlen 3

int left, lastLeft, left_wins;
int right, lastRight, right_wins;
int ballx, bally, ballvx, ballvy;
int* buffer;

void getKey()
{
	int ch=getch();
	while(ch!=ERR)
	{
		lastLeft=left;
		lastRight=right;
		if((ch==KEY_UP) && (right>0))
			right--;
		if((ch==KEY_DOWN) && (right+padlen<=10))
			right++;
		if((ch=='w') && (left>0))
			left--;
		if((ch=='s') && (left+padlen<=10))
			left++;
		if(ch==27)
		{
			endwin();
			exit(1);
		}
		ch=getch();
	}
}

void moveBallY()
{
	if(bally+ballvy<0)
	{
		ballvy=-ballvy;
		bally=ballvy-bally;			
	}
	else if(bally+ballvy>10)
	{
		//bally=10-ballvy+(10-bally)
		bally=20-bally-ballvy;
		ballvy=-ballvy;
	}
	else
		bally+=ballvy;
}

void writeArray()
{
	resetScreen();
	int i;
	writeToArray(255,getPos(ballx,bally));
	for(i=0; i<padlen; i++)
	{
		writeToArray(255, getPos(0,left+i));
		writeToArray(255,getPos(24,right+i));
	}
	//writeToArray(15,getPos(ballx,bally));
}

void writeWins()
{
	if(left_wins>9)
		putNumber(left_wins/10,4,1,128);
	putNumber(left_wins%10,8,1,127);
	
	writeToArray(255, getPos(12,4));
	writeToArray(255, getPos(12,6));
	
	if(right_wins>9)
	{
		putNumber(right_wins/10,14,1,128);
		putNumber(right_wins%10,18,1,128);
	}
	else
		putNumber(right_wins%10,14,1,128);
		
	int row;
	for(row=0;row<11;row++)
	{
		if((row>=left) && (row<left+padlen))
			writeToArray(255,getPos(0,row));
		else
			writeToArray(0,getPos(0,row));
		if((row>=right) && (row<right+padlen))
			writeToArray(255,getPos(24,row));
		else
			writeToArray(0,getPos(24,row));
	}
}

int main(int argc, char *argv[])
{
	if(argc!=3)
	{
		printf("Usage: ./pong <Servername> <Serverport>\n");
		exit(1);
	}
	srand(time(NULL));
	init(argv[1],atoi(argv[2]));
	initscr();
	noecho();
	cbreak();
	keypad(stdscr, TRUE);
	nodelay(stdscr, TRUE);
	
	left=4;
	right=4;
	ballx=12;
	bally=5;
	ballvx=1;
	ballvy=0;
	left_wins=0;
	right_wins=0;
	
	do
	{
		getKey();
		if(ballx+ballvx<=0)
		{
			//ball left
			//printf("left %i\nright %i\nballx %i\nbally %i\nballvx %i\nballvy %i\n",left,right,ballx,bally,ballvx,ballvy);		
			float ratio=-(ballx-1)/ballvx;
			int coll_y=bally+ballvy*ratio;
			//printf("ratio %i\n colly %f\n\n",ratio,coll_y);
			if((coll_y>=left) && (coll_y<left+padlen))
			{
				//left ball hit
				ballx=-ballvx-ballx+2;
				//bally=bally+ballvy;
				ballvx=-ballvx;//+1;
				//ballvy+=(coll_y-left)*(padlen/4)-2;
				//ballvy=rand()%4-2;
				ballvy=ballvy+(coll_y-(left+padlen/2));
			}
			else
			{
				resetScreen();
				right_wins++;
				int i;
				for(i=0; i<15; i++)
				{
					getKey();
					writeWins(15-i);
					display();
					usleep(100000);
				}
				//missed
				ballx=12;
				bally=5;
				ballvx=-1;
				ballvy=0;
			}
		}
		else if(ballx+ballvx>=24)
		{
			//ball right
			//printf("left %i\nright %i\nballx %i\nbally %i\nballvx %i\nballvy %i\n",left,right,ballx,bally,ballvx,ballvy);
			float ratio=(23-ballx)/ballvx;
			int coll_y=bally+ballvy*ratio;
			//printf("ratio %i\n colly %f\n\n",ratio,coll_y);
			if((coll_y>=right) && (coll_y<right+padlen))
			{
				//right ball hit
				ballx=46-ballvx-ballx;
				//bally=bally+ballvy;
				ballvx=-ballvx;//-1;
				//ballvy+=(coll_y-right)*(padlen/4)-2;
				//ballvy=rand()%4-2;
				ballvy=ballvy+(coll_y-(right+padlen/2));
			}
			else
			{
				resetScreen();
				left_wins++;
				int i;
				for(i=0; i<15; i++)
				{
					getKey();
					writeWins(15-i);
					display();
					usleep(100000);
				}
				//missed
				ballx=12;
				bally=5;
				ballvx=1;
				ballvy=0;
			}
		}
		else
		{
			//printf("ballx %i\nballvx %i\nbally %i\nballvy %i\n\n",ballx,ballvx,bally,ballvy);
			ballx+=ballvx;
		}
		moveBallY();
		writeArray();
		display();		
		usleep(60000);
	}while(display());
	endwin();
	return 0;
}
